!/////////////////////////////////////////////////////////////////////////////
!// Name:        m_commun_identifiant.f90
!// Purpose:     Initialisation de tous les identifiants
!//                du répertoire commun
!// Author:      Christophe Guiffaut
!// Modified by:
!// Created:     12 Avril 2006
!// Lieu     : XLIM - Faculté des sciences - 123 Av. Albert Thomas - Limoges
!// Copyright:   (c) CNRS, Université de Limoges
!// Licence  : CECILL-C - Octobre 2006
!/////////////////////////////////////////////////////////////////////////////

module m_commun_identifiant

implicit none

!*** Commun à différents blocs ***
character(LEN=*), parameter :: ID_COORD_REEL='coord_reel'
character(LEN=*), parameter :: ID_COORD_CELL='coord_cell'

character(LEN=*), parameter :: ID_EVAL_TMAX    ='eval_tmax'
character(LEN=*), parameter :: ID_FIN_EVAL_TMAX='fin_eval_tmax'

!*** BLOC <surface_huygens> ***
character(LEN=*), parameter :: BLOC_SURFACE_HUYGENS = 'surface_huygens'
character(LEN=*), parameter :: BSH_SURF = 'SURF'
character(LEN=*), parameter :: BSH_CENTRE_PHASE = 'centre_phase'
character(LEN=*), parameter :: BSH_ORIGINE = 'origine'

!*** BLOC <zone_angulaire> ***
character(LEN=*), parameter :: BLOC_ZONE_ANGULAIRE ='zone_angulaire'


!*** BLOC <milieu_simple> ***
character(LEN=*), parameter :: BLOC_MILIEU_SIMPLE = 'milieu_simple'
character(LEN=*), parameter :: BLOC_MILIEU_DISPERSIF = 'milieu_dispersif'

character(LEN=*), parameter :: BMS_MILIEU  = 'milieu'

character(LEN=*), parameter :: BMS_EPSR  = 'epsr'
character(LEN=*), parameter :: BMS_EPSRX = 'epsrx'
character(LEN=*), parameter :: BMS_EPSRY = 'epsry'
character(LEN=*), parameter :: BMS_EPSRZ = 'epsrz'

character(LEN=*), parameter :: BMS_MUR   = 'mur'
character(LEN=*), parameter :: BMS_MURX  = 'murx'
character(LEN=*), parameter :: BMS_MURY  = 'mury'
character(LEN=*), parameter :: BMS_MURZ  = 'murz'

character(LEN=*), parameter :: BMS_SIGE   = 'sige'
character(LEN=*), parameter :: BMS_SIGEX  = 'sigex'
character(LEN=*), parameter :: BMS_SIGEY  = 'sigey'
character(LEN=*), parameter :: BMS_SIGEZ  = 'sigez'

character(LEN=*), parameter :: BMS_SIGH   = 'sigh'
character(LEN=*), parameter :: BMS_SIGHX  = 'sighx'
character(LEN=*), parameter :: BMS_SIGHY  = 'sighy'
character(LEN=*), parameter :: BMS_SIGHZ  = 'sighz'

!*** BLOC <descrition_circuit> ***
integer, parameter          :: CIRCUIT_CC         = 0
integer, parameter          :: CIRCUIT_CO         = 1
integer, parameter          :: CIRCUIT_CLA        = 2
integer, parameter          :: CIRCUIT_RLC        = 3
integer, parameter          :: CIRCUIT_GENERATEUR = 4
integer, parameter          :: CIRCUIT_VAL        = 5

integer, parameter          :: CIRCUIT_R          = 10
integer, parameter          :: CIRCUIT_L          = 11
integer, parameter          :: CIRCUIT_C          = 12
integer, parameter          :: CIRCUIT_RLCP       = 13
integer, parameter          :: CIRCUIT_RLCS       = 14
integer, parameter          :: CIRCUIT_GV         = 15
integer, parameter          :: CIRCUIT_GI         = 16
integer, parameter          :: CIRCUIT_ZPADE      = 20 !ZPade
integer, parameter          :: CIRCUIT_QZPADE     = 21 !Quadripoles ZPade
integer, parameter          :: CIRCUIT_QZPC       = 22 !Quadripoles ZPade Chainés

character(LEN=*), parameter :: BLOC_CIRCUIT = 'circuit'
character(LEN=*), parameter :: BC_R     = 'R'
character(LEN=*), parameter :: BC_L     = 'L'
character(LEN=*), parameter :: BC_C     = 'C'
character(LEN=*), parameter :: BC_RLCP  = 'RLCP'
character(LEN=*), parameter :: BC_RLCS  = 'RLCS'
character(LEN=*), parameter :: BC_ZPADE = 'ZP'
character(LEN=*), parameter :: BC_ZCPADE= 'ZCP'
character(LEN=*), parameter :: BC_QZPADE= 'QZP'
character(LEN=*), parameter :: BC_QZPC  = 'QZC'
character(LEN=*), parameter :: BC_GV    = 'GV'
character(LEN=*), parameter :: BC_GI    = 'GI'

character(LEN=*), parameter :: BC_CLA    = 'CLA'
character(LEN=*), parameter :: BC_CO     = 'CO'
character(LEN=*), parameter :: BC_CC     = 'CC'

end module m_commun_identifiant

