!/////////////////////////////////////////////////////////////////////////////
!// Name:        m_constantes_scientifiques.f90
!// Purpose:     Liste de constantes physiques communes
!// Author:      Christophe Guiffaut
!// Modified by:  Christophe Guiffaut
!// Lieu     :  Faculté des sciences - 123 Av. Albert Thomas - Limoges
!// Created  :     Novembre 2001
!// Copyright:   (c) CNRS, Université de Limoges
!// Licence  : CECILL-C - Octobre 2006
!/////////////////////////////////////////////////////////////////////////////

!================================================================
!==                 constantes  scientifiques                  ==
!================================================================
module m_constantes_scientifiques
implicit none

!=== Déclaration des types ===
real, parameter  :: EPSILON_0 = 8.854187818e-12
!real, parameter  :: EPSILON_0 = 8.854187818e-10  !eps0*100
real, parameter  :: MU_0      = 12.5663706144e-7
real, parameter  :: PI        = 3.141592654
!real, parameter  :: CVIDE     = 29979245.80 ! c/10
real, parameter  :: CVIDE     = 299792458.0
real, parameter  :: ZVIDE     = 376.730313461
!real             :: CVIDE,ZVIDE
real             :: UNSUR4PIC,Z0SUR4PIC

contains

! ==========================================================
! == Subroutine contantes_initdefaut                      ==
! == Calcul de constantes scientifiques                   ==
! ==========================================================	
subroutine contantes_initdefaut

!CVIDE = 1/SQRT(EPSILON_0*MU_0)
!ZVIDE = SQRT(MU_0/EPSILON_0)
Z0SUR4PIC = ZVIDE/(4.0*PI*CVIDE)
UNSUR4PIC = 1.0/(4.0*PI*CVIDE)

end subroutine contantes_initdefaut

end module m_constantes_scientifiques	


