!/////////////////////////////////////////////////////////////////////////////
!// Name:        m_es_identifiant.f90
!// Purpose:     Initialisation de tous les identifiants du fichier
!//                d'entrée pour les entrée-sorties
!// Author:      Christophe Guiffaut
!// Modified by:
!// Lieu     : XLIM - Faculté des sciences - 123 Av. Albert Thomas - Limoges
!// Created  :     02 janvier 2006
!// Copyright:   (c) CNRS, Université de Limoges
!// Licence  : CECILL-C - Octobre 2006
!/////////////////////////////////////////////////////////////////////////////

module m_es_identifiant

implicit none

! -- Fichier de sortie --
integer, parameter :: FORMAT_ASCII  = 1
integer, parameter :: FORMAT_NETCDF = 2
integer, parameter :: FORMAT_HDF5   = 3
integer, parameter :: LEN_EXTENSION = 4

character(LEN=*), parameter :: EXTENSION = '.dat'
character(LEN=*), parameter :: SUFFIXE_TEMP = '_t'
character(LEN=*), parameter :: SUFFIXE_FREQ = '_f'
character(LEN=*), parameter :: MANTISSE_REEL = 'ES16.7E3'
character(LEN=*), parameter :: MANTISSE_ENTIER = 'I7'
character(LEN=*), parameter :: FS_MANTISSE_REEL = 'ES16.7E3'
character(LEN=*), parameter :: FS_MANTISSE_ENTIER = 'I7'

! -- Commutateur de formatage de TF --
character(LEN=*), parameter :: COM_REELLE_IMAGINAIRE = 'reelle_imaginaire'
character(LEN=*), parameter :: COM_MODULE_PHASE = 'module_phase'
character(LEN=*), parameter :: COM_MODULE_DB_PHASE = 'module_db_phase'
integer, parameter :: REELLE_IMAGINAIRE = 1
integer, parameter :: MODULE_PHASE = 2
integer, parameter :: MODULE_DB_PHASE = 3
integer, parameter :: MODULE_DBW = 4
integer, parameter :: MODULE_SEUL = 5
integer, parameter :: MODULE_DB = 6

!*** BLOC <fichier_sortie> ***
character(LEN=*), parameter :: BLOC_FICHIER_SORTIE = 'fichier_sortie'
character(LEN=*), parameter :: BFS_FORMAT          = 'format'
character(LEN=*), parameter :: BFS_PREFIXE         = 'prefixe'
character(LEN=*), parameter :: BFS_EXTENSION       = 'extension'
character(LEN=*), parameter :: BFS_MANTISSE_REEL   = 'mantisse_reel'
character(LEN=*), parameter :: BFS_MANTISSE_ENTIER = 'mantisse_entier'
character(LEN=*), parameter :: BFS_FUSION          = 'fusion'

!*** BLOC <temps_frequence> ***
character(LEN=*), parameter :: BLOC_TEMPS_FREQUENCE = 'temps_frequence'
character(LEN=*), parameter :: BTF_IT = 'IT'
character(LEN=*), parameter :: BTF_IF = 'IF'
character(LEN=*), parameter :: BTF_LT = 'LT'
character(LEN=*), parameter :: BTF_LF = 'LF'
character(LEN=*), parameter :: BTF_IL = 'IL'
character(LEN=*), parameter :: BTF_ECH_FMAX = 'echantillon_fmax'
character(LEN=*), parameter :: BTF_FREQ_ECH = 'frequence_ech'
character(LEN=*), parameter :: BTF_AUTO = 'auto'
character(LEN=*), parameter :: BTF_TOUS = 'tous'
character(LEN=*), parameter :: BTF_ECRIT_BASE = 'ecrit_base'


end module m_es_identifiant

