!/////////////////////////////////////////////////////////////////////////////
!// Name:        mfdtd_champ_lointain_surface.f90
!// Purpose:     COntient des données communs à au moins deux modules
!      Simulateur FDTD
!// Author:      Christophe Guiffaut
!// Modified by:  Christophe Guiffaut
!// Created  :   -  Juillet 2005
!// Lieu     : XLIM - Faculté des sciences - 123 Av. Albert Thomas - Limoges
!// Copyright:   (c) CNRS, Université de Limoges
!// Licence  : CECILL-C - Octobre 2006
!/////////////////////////////////////////////////////////////////////////////

module champ_lointain_surface

integer, parameter  :: NB_SURFACE_HUYGENS_MAX = 6

type st_pointeur_champ_surface
   integer  :: n1, n2
   integer  :: ideb, ifin, jdeb, jfin, position
   ! pour l'image de la surface
   integer  :: dec_position, signe_i, signe_j
   real, pointer, dimension(:,:)       :: e1,e2,h1,h2
   complex, pointer, dimension(:,:,:)  :: J1, J2, M1, M2
   real, pointer, dimension(:)         :: rscosfiJ1, rscosfiJ2
   real, pointer, dimension(:)         :: rscosfiM1, rscosfiM2
end type st_pointeur_champ_surface
  
end module champ_lointain_surface
