!/////////////////////////////////////////////////////////////////////////////
!// Name:        mfdtd_fdtd.f90
!// Purpose:     Module global contenant la structure globale du programme et
!                  qui intègrent toutes les autres structures
!// Author:      Christophe Guiffaut
!// Modified by:  Christophe Guiffaut
!// Lieu     :  Faculté des sciences - 123 Av. Albert Thomas - Limoges
!// Created  :  Novembre 2001
!// Copyright:   (c) Christophe Guiffaut, équipe CNRS IRCOM/DEM
!//              Utilisation des sources réservées à l'IRCOM
!// Licence  :
!/////////////////////////////////////////////////////////////////////////////

module mfdtd_fdtd3d 

use m_constantes
use m_constantes_scientifiques, only : contantes_initdefaut
use m_es_identifiant
use m_gene_identifiant
use m_commun_identifiant
use m_entree, only : st_fichier, &
                lineread, &
		entree_sortie_initdefaut, &
		entree_nettoyage_fichier,&
		SYMBOLE_DEBUTBLOC,SYMBOLE_FINBLOC,&
		unitefichier, &
		lecture_stop, &
		apres_fin_bloc,&
		temsi_rewind, &
		FIN_FICHIER
! -- Gestion des fichiers de sorties ASCII  --
use m_sortie, only : st_fichier_sortie, &
                fichier_sortie_initdefaut, &
		fichier_sortie_lecture, &
		fichier_sortie_ecriture,&
		fichier_sortie_init, &
		fichier_sortie_precalcul, &
		fichier_sortie_fermeture,&
		ouvre_en_ecriture
use m_maillage

use mfdtd_cao
use mfdtd_identifiant
use mfdtd_volume,only : st_volume, &
		volume_lecture, &
		volume_ecriture, &
		volume_init, &
		volume_maillage_NU_init,&
		volume_precalcul, &
		volume_affichage, &
		volume_deallocate			  

use mfdtd_milieu_volume, only : st_milieu_volume, &
                                 milieu_volume_initdefaut, &
                                 milieu_volume_init, &
				 milieu_volume_precalcul, &
				 milieu_volume_deallocate

use mfdtd_frontiere,      only : st_frontiere, &
		frontiere_initdefaut, &
                frontiere_lecture, &
		frontiere_ecriture, &
                frontiere_precalcul, &
		frontiere_affichage, &
		frontiere_preinit,frontiere_init, &
                frontiere_calcul_h, &
		frontiere_calcul_e, &
		frontiere_deallocate
				  
use mfdtd_champ,only :  st_champ, &
                champ_initdefaut, &
		champ_init, &
		champ_precalcul, &
                champ_calcul_h, &
		champ_calcul_e, &
		champ_annule_e_tangent_metal,&
		champ_deallocate


		      
use m_liste_milieu, only : st_liste_milieu_simple, &
                liste_milieu_simple_initdefaut, &
		liste_milieu_lecture, &
		liste_milieu_simple_ecriture, &
		liste_milieu_simple_init, &
		liste_milieu_simple_deallocate, &
		liste_milieu_simple_affichage

use m_milieu_dispersif, only :  st_milieu_dispersif, &
                milieu_dispersif_lecture, &
		milieu_dispersif_ecriture,&
		milieu_dispersif_init, &
		milieu_dispersif_affichage

use mfdtd_structure_dispersive, only :  st_structure_dispersive, &
                structure_dispersive_initdefaut, &
		structure_dispersive_precalcul, &
		structure_dispersive_affichage, &
		structure_dispersive_E_calcul_E, &
		structure_dispersive_H_calcul_H, &
		structure_dispersive_E_calcul_J, &
		structure_dispersive_H_calcul_M

use mfdtd_structure,      only :  st_structure, &
                structure_initdefaut, &
                structure_lecture, &
		structure_ecriture, &
		structure_init, &
		structure_deallocate, &
		structure_affichage,SIBC_ALGO_ARETE_PADE,&
		SIBC_ALGO_FACE_EXP,SIBC_ALGO_FACE_PADE
				   
				   
use mfdtd_onde_plane,     only :  st_onde_plane, onde_plane_lecture,&
                                   onde_plane_ecriture,&
                                   onde_plane_precalcul, &
				   onde_plane_calcul_champh, &
				   onde_plane_calcul_champe, &
				   onde_plane_calcul_ptref, &
				   onde_plane_impression, &
				   onde_plane_deallocate


use mfdtd_source_courant, only :  st_source_courant, &
                                   source_courant_lecture, &
				   source_courant_ecriture,&
				   source_courant_precalcul, &
				   source_courant_alias_champ, &
				   source_courant_calcul, &
				   source_courant_affichage, &
				   source_courant_deallocate
				   
use mfdtd_source_tension, only :  st_source_tension, &
                                   source_tension_lecture, &
				   source_tension_ecriture,&
				   source_tension_precalcul, &
				   source_tension_alias_champ, &
				   source_tension_calcul, &
				   source_tension_affichage, &
				   source_tension_deallocate


use m_generateur,     only :  st_generateur, &
                                   generateur_lecture, &
				   generateur_ecriture,&
				   generateur_init, &
				   generateur_deallocate, &
				   generateur_impression

use mfdtd_structure_fil, only : st_structure_fil, &
                                 structure_fil_lecture, &
				 structure_fil_ecriture,&
                                 structure_fil_precalcul, &
                                 structure_fil_alias_champ, &
				 structure_fil_affichage, &
                                 structure_fil_calcul_Qjonction, &
                                 structure_fil_calcul_Q_E, &
                                 structure_fil_calcul_Emoy_I, &
                                 structure_fil_deallocate

				 

! -- Prise des listes et intervalles temporels 
! -- et frequentiels pour les resultats --
use m_temps_frequence, only : st_liste_temps_freq, &
                                    st_temps_frequence, &
				    liste_temps_freq_lecture, &
				    liste_temps_freq_ecriture,&
				    liste_temps_freq_initdefaut, &
				    liste_temps_freq_init, &
				    liste_temps_freq_affichage, &
				    liste_temps_freq_precalcul, &
				    liste_temps_freq_calcul

! -- gestion de surfaces fermées --
use m_surface_huygens, only : st_surface_huygens, &
                                   surface_huygens_initdefaut, &
				   surface_huygens_lecture, &
				   surface_huygens_ecriture,&
				   surface_huygens_deallocate
				   


! -- gestion de zones angulaires --
use m_zone_angulaire, only : st_zone_angulaire, &
                                  zone_angulaire_initdefaut, &
				  zone_angulaire_lecture, &
				  zone_angulaire_ecriture,&
				  zone_angulaire_init, &
				  zone_angulaire_deallocate


! -- Post traitement --
use mfdtd_resultat_v_i_z, only : st_resultat_v_i_z, &
                           	  resultat_v_i_z_lecture, &
				  resultat_v_i_z_ecriture,&
                           	  resultat_v_i_z_precalcul, &
                           	  resultat_v_i_z_calcul, &
                           	  resultat_v_i_z_impression, &
                           	  resultat_v_i_z_deallocate


use mfdtd_resultat_champ, only : st_resultat_champ, &
                                  resultat_champ_initdefaut, &
                           	  resultat_champ_lecture, &
				  resultat_champ_ecriture,&
                           	  resultat_champ_precalcul, &
                           	  resultat_champ_calcul, &
                           	  resultat_champ_impression, &
                           	  resultat_champ_deallocate
				       
use mfdtd_resultat_champ_surf, only : st_resultat_champ_surf, &
                           	  resultat_champ_surf_lecture, &
				  resultat_champ_surf_ecriture,&
                           	  resultat_champ_surf_precalcul, &
                           	  resultat_champ_surf_calcul, &
                           	  resultat_champ_surf_impression, &
                           	  resultat_champ_surf_deallocate

use mfdtd_resultat_champ_volume, only : st_resultat_champ_volume, &
                           	  resultat_champ_vol_lecture, &
				  resultat_champ_vol_ecriture,&
                           	  resultat_champ_vol_precalcul1, &
                           	  resultat_champ_vol_precalcul2, &
				  resultat_champ_vol_impression, &
				  resultat_champ_vol_calcul, &
                           	  resultat_champ_vol_deallocate



use mfdtd_resultat_structure_fil, only : st_resultat_structure_fil, &
                                          resultat_fil_initdefaut, &
                                          resultat_structure_fil_lecture, &
					  resultat_structure_fil_ecriture,&
					  resultat_structure_fil_init, &
					  resultat_fil_precalcul, &
					  resultat_fil_affichage, &
					  resultat_structure_fil_calcul, &
					  resultat_fil_impression, &
					  resultat_fil_fermeture, &
					  resultat_fil_deallocate



! -- Calcul des champs lointains --
use mfdtd_champ_lointain_freq, only :  st_champ_lointain_freq, &
                                        champ_lointain_freq_initdefaut, &
					champ_lointain_freq_lecture, &
					champ_lointain_freq_ecriture,&
					champ_lointain_freq_init, &
					champ_lointain_freq_precalcul,& 
					champ_lointain_freq_alias_champ, &
					champ_lointain_freq_calcul, &
					champ_lointain_freq_affichage, &
					champ_lointain_freq_postcalcul, &
					champ_lointain_freq_impression, &
					champ_lointain_freq_deallocate
					

use mfdtd_temps_cpu,  only :  st_temps_cpu, temps_cpu_initdefaut,temps_cpu_affichage
			       


implicit none

! ==========================================================
! == Declaration des types                                ==
! == Type st_fdtd3d                                       ==
! ==========================================================

type st_fdtd3d
  type(st_fichier)                            :: t_fichier
  type(st_fichier_sortie)                     :: t_fichier_sortie
  
  type(st_maillage)                           :: t_maillage
  type(st_volume)                             :: t_volume
  
  logical :: flag_frontiere
  type(st_frontiere)                          :: t_frontiere
  
  logical :: flag_champ
  type(st_champ)                              :: t_champ


  type(st_milieu_volume)                      :: t_milieu_volume
  type(st_temps_cpu)                          :: t_temps_cpu

  logical :: flag_structure
  type(st_structure)                          :: t_structure


  logical :: flag_cao
  type(st_cao),pointer                        :: t_cao



  logical :: flag_liste_milieu_simple
  type(st_liste_milieu_simple), pointer :: t_liste_milieu_simple

  logical :: flag_milieu_dispersif
  type(st_milieu_dispersif), pointer          :: t_milieu_dispersif

  logical :: flag_structure_dispersive
  type(st_structure_dispersive), pointer          :: t_structure_dispersive


  logical :: flag_onde_plane
  type(st_onde_plane), pointer                :: t_onde_plane

  logical :: flag_source_courant
  type(st_source_courant), pointer            :: t_source_courant

  logical :: flag_source_tension
  type(st_source_tension), pointer            :: t_source_tension

  logical :: flag_generateur
  type(st_generateur), pointer                :: t_generateur

  
  logical :: flag_structure_fil
  type(st_structure_fil), pointer :: t_structure_fil
  

  logical :: flag_liste_temps_freq
  type(st_liste_temps_freq), pointer :: t_liste_temps_freq
  
  logical :: flag_surface_huygens
  type(st_surface_huygens), pointer  :: t_surface_huygens

  logical :: flag_zone_angulaire
  type(st_zone_angulaire), pointer   :: t_zone_angulaire
  !-------------------------------------------------------------------
  logical :: flag_resultat_champ
  type(st_resultat_champ), pointer   :: t_resultat_champ

  logical :: flag_resultat_champ_surf
  type(st_resultat_champ_surf), pointer :: t_resultat_champ_surf

  logical :: flag_resultat_champ_volume
  type(st_resultat_champ_volume), pointer :: t_resultat_champ_volume

  logical :: flag_resultat_v_i_z
  type(st_resultat_v_i_z), pointer   :: t_resultat_v_i_z

  logical :: flag_resultat_structure_fil
  type(st_resultat_structure_fil), pointer  :: t_resultat_structure_fil
  
  !-------------------------------------------------------------------

  logical :: flag_champ_lointain_freq
  type(st_champ_lointain_freq), pointer :: t_champ_lointain_freq

end type st_fdtd3d 

contains

! ==========================================================
! == Subroutine fdtd3d_initdefaut                         ==
! == Initialisation par défaut des variables contenant    ==
! == les paramètres definis par l'utilisateur dans le     ==
! == fichier d'entree                                     ==
! ==========================================================	
subroutine fdtd3d_initdefaut(t_fdtd3d)


type(st_fdtd3d)       :: t_fdtd3d
character(LEN=15)      :: ladate, heure, zone
integer, dimension(8) :: dh


!=== DEBUT DES TRAITMENTS ===

call date_and_time(ladate,heure,zone,dh)


!--- Calcul des constantes scientifiques ---
call contantes_initdefaut


t_fdtd3d%flag_frontiere         = .false.
t_fdtd3d%flag_cao               = .false.
t_fdtd3d%flag_champ             = .false.
t_fdtd3d%flag_generateur        = .false.
t_fdtd3d%flag_onde_plane        = .false.
t_fdtd3d%flag_source_courant    = .false.
t_fdtd3d%flag_source_tension    = .false.
nullify(t_fdtd3d%t_cao)
nullify(t_fdtd3d%t_generateur)
nullify(t_fdtd3d%t_onde_plane)
nullify(t_fdtd3d%t_source_courant)
nullify(t_fdtd3d%t_source_tension)


t_fdtd3d%flag_liste_milieu_simple     = .false.
t_fdtd3d%flag_milieu_dispersif        = .false.
t_fdtd3d%flag_structure_dispersive    = .false.
nullify(t_fdtd3d%t_milieu_dispersif)
nullify(t_fdtd3d%t_structure_dispersive)

!t_fdtd3d%flag_structure_rugueuse= .false.
t_fdtd3d%flag_structure_fil     = .false.

!nullify(t_fdtd3d%t_structure_rugueuse)
nullify(t_fdtd3d%t_structure_fil)

t_fdtd3d%flag_liste_temps_freq  = .false.
t_fdtd3d%flag_surface_huygens   = .false.
t_fdtd3d%flag_zone_angulaire    = .false.
allocate(t_fdtd3d%t_liste_temps_freq)
nullify(t_fdtd3d%t_surface_huygens)
nullify(t_fdtd3d%t_zone_angulaire)

t_fdtd3d%flag_resultat_champ       = .false.
t_fdtd3d%flag_resultat_champ_surf  = .false.
t_fdtd3d%flag_resultat_champ_volume= .false.
t_fdtd3d%flag_resultat_v_i_z       = .false.
t_fdtd3d%flag_resultat_structure_fil = .false.
nullify(t_fdtd3d%t_resultat_champ)
nullify(t_fdtd3d%t_resultat_champ_surf)
nullify(t_fdtd3d%t_resultat_champ_volume)
nullify(t_fdtd3d%t_resultat_v_i_z)
nullify(t_fdtd3d%t_resultat_structure_fil)

t_fdtd3d%flag_champ_lointain_freq  = .false.
nullify(t_fdtd3d%t_champ_lointain_freq)

allocate(t_fdtd3d%t_liste_milieu_simple)
call liste_milieu_simple_initdefaut(t_fdtd3d%t_liste_milieu_simple)
t_fdtd3d%flag_liste_milieu_simple = .true.

t_fdtd3d%flag_structure         = .false.
call structure_initdefaut(t_fdtd3d%t_structure)

call entree_sortie_initdefaut(t_fdtd3d%t_fichier)
call fichier_sortie_initdefaut(t_fdtd3d%t_fichier_sortie)
call frontiere_initdefaut(t_fdtd3d%t_frontiere)
call champ_initdefaut (t_fdtd3d%t_champ)

call maillage_initdefaut(t_fdtd3d%t_maillage)

call milieu_volume_initdefaut(t_fdtd3d%t_milieu_volume,t_fdtd3d%t_liste_milieu_simple)
end Subroutine fdtd3d_initdefaut


! ==========================================================
! == Subroutine fdtd3d_lecture                            ==
! == Lecture dans le fichier d'entrée...                  ==
! ==========================================================	
subroutine fdtd3d_lecture(t_fdtd3d)

type(st_fdtd3d), intent(inout) :: t_fdtd3d

integer :: i,unite,statut
character(len=LEN_CHAINE) :: nombloc,nom_repertoire
logical :: flag_volume,flag_frontiere


!-------------------------------------------------------------
! -- Recupere un descripteur libre le fichier d'entree --
!-------------------------------------------------------------
unite =  unitefichier()
if (unite<=0) then
  print '(/,t10,"ATTENTION, pas de descripteur de fichier disponible => STOP !!!")'
  stop
endif


!-------------------------------------------------------------
! -- Ouvre le fichier d'entree en lecture --
!-------------------------------------------------------------
open(unite,file=t_fdtd3d%t_fichier%nom_fichier,status = 'old',action='read',iostat=statut)
if (statut>0) then
  print '(/,t10,"ATTENTION, ouverture de ",A," impossible => STOP !!!")', &
    TRIM(t_fdtd3d%t_fichier%nom_fichier)
  stop
endif

t_fdtd3d%t_fichier%unite = unite


!-------------------------------------------------------------
! -- Récupère le nom du répertoire --
!-------------------------------------------------------------
i= SCAN(t_fdtd3d%t_fichier%nom_fichier,"\/",.true.)
nom_repertoire ='';
if (i>0) nom_repertoire = t_fdtd3d%t_fichier%nom_fichier(1:i);
if (rang==RANG_MAITRE_AFF) &
  print '("Répertoire d''exécution =",A)',trim(nom_repertoire)
t_fdtd3d%t_fichier%nom_repertoire=nom_repertoire


!-------------------------------------------------------------
! -- Lecture de tous les blocs de données : Nettoyage commentaire ... --
call entree_nettoyage_fichier(t_fdtd3d%t_fichier)
!-------------------------------------------------------------

!-------------------------------------------------------------
! -- Lecture uniquement des blocs volume et frontiere
! -- Besoin du volume et du type de frontières -- 
!-------------------------------------------------------------
flag_volume=.false.
flag_frontiere=.false.
do
  nombloc = lineread(t_fdtd3d%t_fichier)
  select case (nombloc)
    ! -- Gestion des caracteristiques generales du volume de calcul --
    case(BLOC_VOLUME,'volume_de_calcul')
      if (rang==RANG_MAITRE_AFF) print '(" Lecture du bloc : ",A)', TRIM(nombloc)
      call volume_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_volume)
      
      flag_volume=.true.
    ! -- Gestion des frontieres : PML, mur electriques magnetques, sans frontieres --
    case(BLOC_FRONTIERE,'frontieres')
      if (.not.flag_volume) then
        if (rang==RANG_MAITRE_AFF) &
	  print '(" ERREUR, Le bloc <volume_calcul> doit etre présent avant le bloc <frontiere> !!!")'
        call lecture_stop(t_fdtd3d%t_fichier) 
      end if
      
      if (rang==RANG_MAITRE_AFF) print '(" Lecture du bloc : ",A)', TRIM(nombloc)
      call frontiere_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_frontiere)
      flag_frontiere=.true.
    case(FIN_FICHIER,'fin_fichier>')
      exit ! -- Sortie de la boucle --

    case default
      call apres_fin_bloc(t_fdtd3d%t_fichier)
  end select
  
  if (flag_volume .and.flag_frontiere) exit ! on sort
end do


!--> Calcul du nombre de cellules PML , mise à jour des bornes du volume
call volume_init(t_fdtd3d%t_volume)
call frontiere_preinit(t_fdtd3d%t_frontiere,t_fdtd3d%t_volume)

!--> Cas du maillage non uniforme ---
if (t_fdtd3d%t_volume%flag_maillage_nu) then
  call volume_maillage_NU_init(t_fdtd3d%t_volume)
end if

call maillage_init(t_fdtd3d%t_maillage,t_fdtd3d%t_volume%dt,t_fdtd3d%t_volume%dxyz,&
                    t_fdtd3d%t_volume%nxyz,t_fdtd3d%t_volume%type_volume,&
		    t_fdtd3d%t_volume%origine_cell,t_fdtd3d%t_volume%origine)

!--> On remonte au début du ficheir
call temsi_rewind(t_fdtd3d%t_fichier)

!-------------------------------------------------------------
! -- Lecture de toutes les données ... --
!-------------------------------------------------------------

do 
  ! -- Lecture des lignes commencant par "<" --
  ! -- nombloc : chaine qui suit ls "<" --
  nombloc = lineread(t_fdtd3d%t_fichier)
  print '("Lecture du bloc : ",A)', TRIM(nombloc)
  
  select case (nombloc)
    ! -- Gestion des caracteristiques generales du volume de calcul --
    case(BLOC_VOLUME,'volume_de_calcul')
      call apres_fin_bloc(t_fdtd3d%t_fichier)
      
    ! -- Gestion des frontieres : PML, mur electriques magnetques, sans frontieres --
    case(BLOC_FRONTIERE,'frontieres')
      call apres_fin_bloc(t_fdtd3d%t_fichier)
      
    ! -- Gestion du format du/des fichiers de sortie --
    case(BLOC_FICHIER_SORTIE)
      call fichier_sortie_lecture(t_fdtd3d%t_fichier, &
                                     t_fdtd3d%t_fichier_sortie)

    case(BLOC_CAO)
      allocate(t_fdtd3d%t_cao)
      call cao_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_cao,t_fdtd3d%t_maillage)
      if (t_fdtd3d%t_cao%flag_data) then
        t_fdtd3d%flag_cao = .true.
      else
        deallocate(t_fdtd3d%t_cao)
      end if

    ! -- Gestion des generateurs --
    case('generateur',BLOC_FONCTION_SOURCE)

      allocate(t_fdtd3d%t_generateur)
      call generateur_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_generateur)
      t_fdtd3d%flag_generateur = .true.

      
    ! -- Gestion des sources de courant (pas filaires) --
    case(BLOC_SOURCE_COURANT)
      allocate(t_fdtd3d%t_source_courant)
      call source_courant_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_source_courant,&
                                  t_fdtd3d%t_maillage,t_fdtd3d%t_generateur)
      if (t_fdtd3d%t_source_courant%flag_data) then
        t_fdtd3d%flag_source_courant = .true.
      else
        deallocate(t_fdtd3d%t_source_courant)
      end if

    ! -- Gestion des sources de tension (pas filaires) --
    case(BLOC_SOURCE_TENSION)
      allocate(t_fdtd3d%t_source_tension)
      call source_tension_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_source_tension,&
                                  t_fdtd3d%t_maillage,t_fdtd3d%t_generateur)
      if (t_fdtd3d%t_source_tension%flag_data) then
        t_fdtd3d%flag_source_tension = .true.
      else
        deallocate(t_fdtd3d%t_source_tension)
      end if
      
    ! -- Gestion des injecteurs d'ondes planes (boites d'huygens) --
    case(BLOC_ONDE_PLANE)
      allocate(t_fdtd3d%t_onde_plane)
      call onde_plane_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_onde_plane,t_fdtd3d%t_liste_temps_freq,&
                              t_fdtd3d%t_maillage,t_fdtd3d%t_generateur)
			      
      t_fdtd3d%flag_onde_plane = .true.

    ! -- Gestion des milieux non dispersifs (permitivite, permeabilite, pertes elec et magn) --
    case(BLOC_MILIEU_SIMPLE,'milieu_non_dispersif')
      call liste_milieu_lecture(t_fdtd3d%t_fichier, &
				t_fdtd3d%t_liste_milieu_simple,&
				t_fdtd3d%t_maillage)
       
    ! -- Gestion des milieux dispersifs --
    case(BLOC_MILIEU_DISPERSIF)
      allocate(t_fdtd3d%t_milieu_dispersif)
      call milieu_dispersif_lecture(t_fdtd3d%t_fichier, &
                                    t_fdtd3d%t_milieu_dispersif)
      if (t_fdtd3d%t_milieu_dispersif%nb_milieu <= 0) then
        deallocate(t_fdtd3d%t_milieu_dispersif)
      else
        t_fdtd3d%flag_milieu_dispersif = .true.
	if (.not. t_fdtd3d%flag_liste_milieu_simple) then
          allocate(t_fdtd3d%t_liste_milieu_simple)
          call liste_milieu_simple_initdefaut(t_fdtd3d%t_liste_milieu_simple)
	  t_fdtd3d%flag_liste_milieu_simple = .true.
	end if
      end if
      
    ! -- Gestion des structures metalliques et dielectriques --
    case(BLOC_STRUCTURE)
      call structure_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_structure,t_fdtd3d%t_maillage)
      t_fdtd3d%flag_structure = .true.

    !--------------------------------------------------------------------------
    ! -- Gestion des structures filaires (Holland) --
    case(BLOC_FIL)
      allocate(t_fdtd3d%t_structure_fil)
      call structure_fil_lecture(t_fdtd3d%t_fichier, &
                                     t_fdtd3d%t_structure_fil, &
				     t_fdtd3d%t_volume, &
				     t_fdtd3d%t_generateur,&
				     t_fdtd3d%t_maillage)
      t_fdtd3d%flag_structure_fil = .true.
    !--------------------------------------------------------------------------

    ! -- Gestion des intervalles et echantillons de frequence et de temps --
    ! -- pour les calcul de tf et stockage de resultats --
    case(BLOC_TEMPS_FREQUENCE)
      call liste_temps_freq_initdefaut(t_fdtd3d%t_liste_temps_freq)
      call liste_temps_freq_lecture(t_fdtd3d%t_fichier, &
                                         t_fdtd3d%t_liste_temps_freq)
      t_fdtd3d%flag_liste_temps_freq = .true.

    ! -- Gestion des zones angulaires --
    case(BLOC_ZONE_ANGULAIRE)
      allocate(t_fdtd3d%t_zone_angulaire)
      call zone_angulaire_initdefaut(t_fdtd3d%t_zone_angulaire)
      call zone_angulaire_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_zone_angulaire)
      t_fdtd3d%flag_zone_angulaire = .true.
      
    ! -- Gestion des surfaces de huygens --
    case(BLOC_SURFACE_HUYGENS)
      allocate(t_fdtd3d%t_surface_huygens)
      call surface_huygens_initdefaut(t_fdtd3d%t_surface_huygens)
      call surface_huygens_lecture(t_fdtd3d%t_fichier, t_fdtd3d%t_surface_huygens,t_fdtd3d%t_maillage)
      t_fdtd3d%flag_surface_huygens = .true.
      
    ! -- Gestion des resultats sur des points de champ - temporel et frequentiel --
    case(BLOC_RES_CHAMP_PT)
      allocate(t_fdtd3d%t_resultat_champ)
      call resultat_champ_initdefaut(t_fdtd3d%t_resultat_champ)
      call resultat_champ_lecture(t_fdtd3d%t_fichier, &
                                  t_fdtd3d%t_resultat_champ, &
				  t_fdtd3d%t_liste_temps_freq, &
				  t_fdtd3d%t_maillage,&
				  t_fdtd3d%t_volume%borne_volume)
				  
      if (t_fdtd3d%t_resultat_champ%flag_data) then
        t_fdtd3d%flag_resultat_champ = .true.
      else
        deallocate(t_fdtd3d%t_resultat_champ)
      end if      

    ! -- Gestion des resultats sur des surfaces de champ - temporel et frequentiel --
    case(BLOC_RES_CHAMP_SURF)
      allocate(t_fdtd3d%t_resultat_champ_surf)
      call resultat_champ_surf_lecture(t_fdtd3d%t_fichier, &
                                  t_fdtd3d%t_resultat_champ_surf, &
				  t_fdtd3d%t_liste_temps_freq,&
				  t_fdtd3d%t_maillage)
      if (t_fdtd3d%t_resultat_champ_surf%flag_data) then
        t_fdtd3d%flag_resultat_champ_surf = .true.
      else
        deallocate(t_fdtd3d%t_resultat_champ_surf)
      end if

    ! -- Gestion des resultats sur des volumes de champ, concerne que les matériaux
    case(BLOC_RES_CHAMP_VOL)
      allocate(t_fdtd3d%t_resultat_champ_volume)
      call resultat_champ_vol_lecture(t_fdtd3d%t_fichier, &
                                  t_fdtd3d%t_resultat_champ_volume,&
				  t_fdtd3d%t_liste_temps_freq,&
				  t_fdtd3d%t_maillage)
      if (t_fdtd3d%t_resultat_champ_volume%flag_data) then
        t_fdtd3d%flag_resultat_champ_volume = .true.
      else
        deallocate(t_fdtd3d%t_resultat_champ_volume)
      end if


    ! -- Gestion des resultats sur les structures filaires - temporel et frequentiel --
    case('resultat_structure_fil')
      if (.not. t_fdtd3d%flag_structure_fil) then
        print '(" Pas de structures filaires de définies ....")'
        print '("Vous me cachez des infos aussi je refuse de continuer dans ces conditions !!! : ")'
        call lecture_stop(t_fdtd3d%t_fichier) 
      end if
      
      allocate(t_fdtd3d%t_resultat_structure_fil)
      call resultat_fil_initdefaut(t_fdtd3d%t_resultat_structure_fil)
      call resultat_structure_fil_lecture(t_fdtd3d%t_fichier, &
                                          t_fdtd3d%t_resultat_structure_fil, &
                                          t_fdtd3d%t_structure_fil, &
					  t_fdtd3d%t_liste_temps_freq)
      t_fdtd3d%flag_resultat_structure_fil = .true.
      

    case(BLOC_RES_V_I_Z)
      allocate(t_fdtd3d%t_resultat_v_i_z)
      call resultat_v_i_z_lecture(t_fdtd3d%t_fichier, &
                                  t_fdtd3d%t_resultat_v_i_z, &
				  t_fdtd3d%t_liste_temps_freq,&
				  t_fdtd3d%t_maillage)
      t_fdtd3d%flag_resultat_v_i_z = .true. 

    case(BLOC_CHAMP_LOINTAIN,'champ_lointain_frequence')
      if (t_fdtd3d%flag_liste_temps_freq .and. t_fdtd3d%flag_zone_angulaire) then
	allocate(t_fdtd3d%t_champ_lointain_freq)
	call champ_lointain_freq_initdefaut(t_fdtd3d%t_champ_lointain_freq)
	call champ_lointain_freq_lecture(t_fdtd3d%t_fichier, &
	                                 t_fdtd3d%t_champ_lointain_freq, & 
					 t_fdtd3d%t_liste_temps_freq, &
					 t_fdtd3d%t_zone_angulaire, &
					 t_fdtd3d%t_surface_huygens, &
					 t_fdtd3d%t_structure, &
					 t_fdtd3d%t_structure_fil,&
					 t_fdtd3d%t_maillage)
					 
        t_fdtd3d%flag_champ_lointain_freq = .true.
      else
        print '(/,"Manque un des blocs suivant pour le champ lointain : ")'
        print '(T10,"surface_huygens ou zone_angulaire ou temps_frequence")'
        call lecture_stop(t_fdtd3d%t_fichier) 
      end if
      
    case(FIN_FICHIER,'fin_fichier>')
      exit ! -- Sortie de la boucle --

    case default
      print '("Arret car nom de bloc non reconnu : ",A)', TRIM(nombloc)
      call lecture_stop(t_fdtd3d%t_fichier) 
  end select

end do

! -- Fermeture du fichier d'entrée --
close(t_fdtd3d%t_fichier%unite)				
end Subroutine fdtd3d_lecture

! ==========================================================
! == Subroutine fdtd3d_ecriture                           ==
! == Lecture dans le fichier d'entrée...                  ==
! ==========================================================	
subroutine fdtd3d_ecriture(fd)

type(st_fdtd3d), intent(inout) :: fd

integer  :: unite
character(len=LEN_MOT_CLE) :: nombloc

unite = ouvre_en_ecriture(fd%t_fichier%nom_fichier,'replace');
fd%t_fichier%unite = unite
write (unite,'(A)') "############################################################"
write (unite,'(A)') "#--> 1- Volume, Maillage et Frontières"
write (unite,'(A)') "############################################################"
write(unite,*)

!--------------------------------------------------------------------
!print '("  ECRITURE du bloc : ",A)', '<volume_calcul>'
write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_VOLUME
call volume_ecriture(fd%t_fichier,fd%t_volume)
write (unite,'(A,A1)') BLOC_VOLUME,SYMBOLE_FINBLOC
!--------------------------------------------------------------------

!--------------------------------------------------------------------
write(unite,*)
!print '("  ECRITURE du bloc : ",A)', '<frontieres>'
write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_FRONTIERE
call frontiere_ecriture(fd%t_fichier,fd%t_frontiere)
write (unite,'(A,A1)') BLOC_FRONTIERE,SYMBOLE_FINBLOC
!--------------------------------------------------------------------


!--------------------------------------------------------------------
write(unite,*)
write (unite,'(A)') "############################################################"
write (unite,'(A)') "#--> 2- Les matériaux"
write (unite,'(A)') "#-->    Les structures maillées (surfacique et volumique)"
write (unite,'(A)') "############################################################"
write(unite,*)

if (fd%flag_liste_milieu_simple) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<milieu_simple>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_MILIEU_SIMPLE
  call liste_milieu_simple_ecriture(fd%t_fichier,fd%t_liste_milieu_simple)
  write (unite,'(A,A1)') BLOC_MILIEU_SIMPLE,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_milieu_dispersif) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<milieu_dispersif>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_MILIEU_DISPERSIF
  call milieu_dispersif_ecriture(fd%t_fichier,fd%t_milieu_dispersif)  
  write (unite,'(A,A1)') BLOC_MILIEU_DISPERSIF,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_structure) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<structure>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_STRUCTURE
  call structure_ecriture(fd%t_fichier,fd%t_structure,fd%t_maillage)
  write (unite,'(A,A1)') BLOC_STRUCTURE,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

write(unite,*)
write (unite,'(A)') "############################################################"
write (unite,'(A)') "#--> 4- Les générateurs"
write (unite,'(A)') "#-->    Les éléments localisés, les structures filaires"
write (unite,'(A)') "############################################################"
write(unite,*)


!--------------------------------------------------------------------
if (fd%flag_generateur) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<fonction_source>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_FONCTION_SOURCE
  call generateur_ecriture(fd%t_fichier,fd%t_generateur)
  write (unite,'(A,A1)') BLOC_FONCTION_SOURCE,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------


!--------------------------------------------------------------------
if (fd%flag_source_courant) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<source_courant>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_SOURCE_COURANT
  call source_courant_ecriture(fd%t_fichier,fd%t_source_courant,fd%t_maillage)  
  write (unite,'(A,A1)') BLOC_SOURCE_COURANT,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_source_tension) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<source_tension>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_SOURCE_TENSION
  call source_tension_ecriture(fd%t_fichier,fd%t_source_tension,fd%t_maillage)  
  write (unite,'(A,A1)') BLOC_SOURCE_TENSION,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------


!--------------------------------------------------------------------
if (fd%flag_onde_plane) then
  write(unite,*)
!  print '("  ECRITURE du bloc : <",A,">")', BLOC_ONDE_PLANE
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_ONDE_PLANE
  call onde_plane_ecriture(fd%t_fichier,fd%t_onde_plane,fd%t_maillage)  
  write (unite,'(A,A1)') BLOC_ONDE_PLANE,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------


!--------------------------------------------------------------------
if (fd%flag_structure_fil) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<structure_fil>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_FIL
  call structure_fil_ecriture(fd%t_fichier,fd%t_structure_fil,fd%t_maillage)
  write (unite,'(A,A1)') BLOC_FIL,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------


!--------------------------------------------------------------------
write(unite,*)
write (unite,'(A)') "############################################################"
write (unite,'(A)') "#--> 5- Post-traitments + Les sorties"
write (unite,'(A)') "############################################################"
write(unite,*)

!print '("  ECRITURE du bloc : ",A)', '<fichier_sortie>'
write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_FICHIER_SORTIE
call fichier_sortie_ecriture(fd%t_fichier,fd%t_fichier_sortie)
write (unite,'(A,A1)') BLOC_FICHIER_SORTIE,SYMBOLE_FINBLOC
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_liste_temps_freq) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<temps_frequence>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_TEMPS_FREQUENCE
  call liste_temps_freq_ecriture(fd%t_fichier,fd%t_liste_temps_freq)
  write (unite,'(A,A1)') BLOC_TEMPS_FREQUENCE,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_surface_huygens) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<surface_huygens>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_SURFACE_HUYGENS
  call surface_huygens_ecriture(fd%t_fichier,fd%t_surface_huygens,fd%t_maillage)
  write (unite,'(A,A1)') BLOC_SURFACE_HUYGENS,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_resultat_structure_fil) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<resultat_structure_fil>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,'resultat_structure_fil'
  call resultat_structure_fil_ecriture(fd%t_fichier,fd%t_resultat_structure_fil)
  write (unite,'(A,A1)') 'resultat_structure_fil',SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------


!--------------------------------------------------------------------
if (fd%flag_resultat_champ) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<resultat_champ_point>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_RES_CHAMP_PT
  call resultat_champ_ecriture(fd%t_fichier,fd%t_resultat_champ,fd%t_maillage)
  write (unite,'(A,A1)') BLOC_RES_CHAMP_PT,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_resultat_champ_surf) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<resultat_champ_surface>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_RES_CHAMP_SURF
  call resultat_champ_surf_ecriture(fd%t_fichier,fd%t_resultat_champ_surf,fd%t_maillage)  
  write (unite,'(A,A1)') BLOC_RES_CHAMP_SURF,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_resultat_champ_volume) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<resultat_champ_volume>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_RES_CHAMP_VOL
  call resultat_champ_vol_ecriture(fd%t_fichier,fd%t_resultat_champ_volume,fd%t_maillage)
  write (unite,'(A,A1)') BLOC_RES_CHAMP_VOL,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_resultat_v_i_z) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<resultat_v_i_z>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_RES_V_I_Z
  call resultat_v_i_z_ecriture(fd%t_fichier,fd%t_resultat_v_i_z,fd%t_maillage)
 write (unite,'(A,A1)') BLOC_RES_V_I_Z,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_zone_angulaire) then
  write(unite,*)
!  print '("  ECRITURE du bloc : ",A)', '<zone_angulaire>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_ZONE_ANGULAIRE
  call zone_angulaire_ecriture(fd%t_fichier,fd%t_zone_angulaire)
  write (unite,'(A,A1)') BLOC_ZONE_ANGULAIRE,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------

!--------------------------------------------------------------------
if (fd%flag_champ_lointain_freq) then
  write(unite,*)
  !print '("  ECRITURE du bloc : ",A)', '<champ_lointain_frequence>'
  write (unite,'(A1,A)') SYMBOLE_DEBUTBLOC,BLOC_CHAMP_LOINTAIN
  call champ_lointain_freq_ecriture(fd%t_fichier,fd%t_champ_lointain_freq,fd%t_maillage)
  write (unite,'(A,A1)') BLOC_CHAMP_LOINTAIN,SYMBOLE_FINBLOC
end if
!--------------------------------------------------------------------



!--------------------------------------------------------------------

close(unite)

end Subroutine fdtd3d_ecriture



! ==========================================================
! == Subroutine fdtd3d_init                     ==
! ==                                                      ==
! == Initialisation des variables, lorsque qu'il n'y a    ==
! == pas de lecture du fichier d'entree                   ==
!===========================================================	
subroutine fdtd3d_init(f)

type(st_fdtd3d), intent(inout) :: f
real :: deltamax
integer :: n

! -- Initialisation du format du/des fichier(s) de sortie --
! -- Creation et ouverture --
print '(T5,"--- INIT FICHIERS DE SORTIE ---")'
call fichier_sortie_init(f%t_fichier_sortie)

! -- Remplissage de la structure des milieux simples ---
if (f%flag_milieu_dispersif) then
  print '(T5,"--- INIT MILIEU DISPERSIF ---")'
  call milieu_dispersif_init(f%t_milieu_dispersif)
end if

! -- Réglage des flags de milieu, création de la structure
!    contentant tous les milieux simples ---
if (f%flag_liste_milieu_simple) then
  print '(T5,"--- INIT LISTE MILIEU SIMPLE ---")'
  call liste_milieu_simple_init(f%t_liste_milieu_simple, &
                                f%t_milieu_dispersif, &
                                f%t_volume%mu_r, f%t_volume%epsilon_r,&
				f%t_volume%sigma_e, f%t_volume%sigma_h)
endif

! -- Recalcul de quelques parametres : pas dt, nb d'iterations, Fait à la lecture --
!print '(T5,"--- INIT VOLUME ---")'
!call volume_init(f%t_volume)


! -- Définition d'un tableau générateur de valeurs nulles (t_generateur%tab_zero)
! -- Besoin du nombre d'itérations temporelles --
if (f%flag_generateur) THEN
  print '(T5,"--- INIT GENERATEUR ---")'
  call generateur_init(f%t_generateur,f%t_liste_temps_freq,f%t_volume%ntinc, &
                       f%t_volume%dt,f%t_volume%type_duree,n)
END IF


! -- A besoin de t_frontiere & t_volume --
! -- Determine le volume reel de calcul --
print '(T5,"--- INIT FRONTIERES ---")'
call frontiere_init(f%t_frontiere,f%t_volume)


! -- Verification sur bandes temporelles et frequencielles pour --
! -- stockage et calculs des TF --
! -- Conversion du temporel en iteration --
if (f%flag_liste_temps_freq) then
  print '(T5,"--- INIT LISTE TEMPS FREQUENCE ---")'
  deltamax = MAXval(f%t_volume%dxyz)
  call liste_temps_freq_init(f%t_liste_temps_freq, f%t_fichier_sortie, &
              f%t_volume%dt,f%t_volume%tlimit,deltamax)
endif


! -- A besoin de connaitre le volume reel de calcul --
if (f%flag_structure) THEN
  print '(T5,"--- INIT STRUCTURE ---")'
  call structure_init(f%t_structure,f%t_volume,f%t_liste_milieu_simple)
END IF

! -- Initialisation des flags correspondants aux pertes homogenes --
print '(T5,"--- INIT CHAMP ---")'
call champ_init(f%t_champ,f%t_volume,f%t_structure,f%t_frontiere%type_face)

! -- Initialisation epsilon défaut, (doit etre après volume_init et structure_init)
print '(T5,"--- INIT MILIEU VOLUME ---")'
call milieu_volume_init(f%t_milieu_volume,f%t_volume,f%t_structure)


!if (f%flag_structure_rugueuse) call structure_rugueuse_init(f%t_structure_rugueuse,f%t_volume)

! -- A besoin de connaitre le volume reel de calcul --
! -- A besoin de connaitre le volume reel de calcul --


! -- Zone angulaire : Conversion des angles en radian --
if (f%flag_zone_angulaire) then
  print '(T5,"--- INIT ZONE ANGULAIRE ---")'
  call zone_angulaire_init(f%t_zone_angulaire)
endif


! -- id et ouverture fichier --
if (f%flag_resultat_structure_fil) then
  print '(T5,"--- INIT STRUCTURE FIL ---")'
  call resultat_structure_fil_init(f%t_resultat_structure_fil, &
                                            f%t_volume, &
				            f%t_fichier_sortie)
endif


! -- champ lointain : RAS --
if (f%flag_champ_lointain_freq) then
  print '(T5,"--- INIT CHAMP LOINTAIN ---")'
  call champ_lointain_freq_init(f%t_champ_lointain_freq)
endif

call fdtd3d_mem_nboper(f)
end subroutine fdtd3d_init

! ==========================================================
! == Subroutine fdtd3d_mem_nboper                         ==
! ==   Evaluation de la taille mémoire en octets dans la
! ==    structure et du nbre d'opération flottante si impactant
! ==     sur le temps de calcul
!===========================================================	
subroutine fdtd3d_mem_nboper(f)
type(st_fdtd3d), intent(inout) :: f

real :: taille_mem, taille_mem_extra
real :: Fa
!

print '(T5,"--- EVALUATION DE L''OCCUPATION MÉMOIRE ---")'
print '(T10,"Mémoire du module structure    = ",EN12.3E2," octets")',f%t_structure%taille_mem
print '(T10,"Mémoire du module milieu_volume= ",EN12.3E2," octets")',f%t_milieu_volume%taille_mem
print '(T10,"Mémoire temporaire eps,mu,sige,sigh et coeff champ = ",EN12.3E2," octets")',&
             f%t_milieu_volume%taille_mem_extra

  
print '(T10,"Mémoire du module frontiere       = ",EN12.3E2," octets")',f%t_frontiere%taille_mem
print '(T10,"Mémoire du module champ           = ",EN12.3E2," octets")',f%t_champ%taille_mem

taille_mem_extra = max(f%t_champ%taille_mem,f%t_milieu_volume%taille_mem_extra)
taille_mem = taille_mem_extra+f%t_structure%taille_mem+f%t_milieu_volume%taille_mem+ &
             f%t_frontiere%taille_mem


print *
print '(T10,"Mémoire Maximale = ",EN12.3E2," octets")',taille_mem
taille_mem = taille_mem - taille_mem_extra +f%t_champ%taille_mem
print '(T10,"Mémoire pendant les itérations temporelles = ",EN12.3E2," octets")',taille_mem

print *
print '(T5,"--- EVALUATION DU TEMPS DE SIMULATION ---")'
  
print '(T10,"Module frontiere       = ",EN12.3E2," FLOPs")',f%t_frontiere%nb_oper
print '(T10,"Module champ           = ",EN12.3E2," FLOPs")',f%t_champ%nb_oper
if (f%t_frontiere%t_cpml%nb_cell_pml>0) then
  Fa = 1.0+(f%t_frontiere%nb_oper/f%t_frontiere%t_cpml%nb_cell_pml)/&
         (f%t_champ%nb_oper/f%t_champ%nb_cell_tot)
  Print '(T10,"Rapport Temps CPU cell PML/Temps CPU cell utile =",F8.3)',Fa
end if
print '(T10,"Nb cellules totale     =",I12," ; Nb cellules PML =",I12)',&
                 f%t_champ%nb_cell_tot,f%t_frontiere%t_cpml%nb_cell_pml
print *

end subroutine fdtd3d_mem_nboper

! ==========================================================
! == Subroutine fdtd3d_precalcul                          ==
! == Calculs avant les itérations temporelles             ==
! ==========================================================	
subroutine fdtd3d_precalcul(t_fdtd3d)

type(st_fdtd3d), intent(inout) :: t_fdtd3d

! -- Preparation du mode ecriture du/des fichier(s) de sortie --
print '(T5,"--- PRECALCUL FICHIERS SORTIE  ---")'
call fichier_sortie_precalcul(t_fdtd3d%t_fichier_sortie)

print '(T5,"--- PRECALCUL VOLUME ---")'
call volume_precalcul(t_fdtd3d%t_volume)

! -- Calcul des parametes epsilon, mu et conductivites --
! -- dans chaque cellule elementaire puis calcul des   --
! -- coefficients multipliatifs des champs --
!if (t_fdtd3d%flag_structure) then
  print '(T5,"--- PRECALCUL MILIEU VOLUME ---")'
  call milieu_volume_precalcul(t_fdtd3d%t_milieu_volume, &
                               t_fdtd3d%t_liste_milieu_simple, &
			       t_fdtd3d%t_volume, &
			       t_fdtd3d%t_champ, &
			       t_fdtd3d%t_structure)
!endif

! -- Les tableaux 3d des eps, mu, sigma equivalents --
! -- sont accessibles maintenant --


! -- Source de courant, a besoin du tableau epsilon --
if (t_fdtd3d%flag_source_courant) then
  print '(T5,"--- PRECALCUL SOURCE COURANT ---")'
  call source_courant_precalcul(t_fdtd3d%t_source_courant, &
                                t_fdtd3d%t_volume, &
				t_fdtd3d%t_milieu_volume, &
				t_fdtd3d%t_generateur)
end if


! -- Source de tension, a besoin du tableau epsilon --
if (t_fdtd3d%flag_source_tension) then
  print '(T5,"--- PRECALCUL SOURCE TENSION ---")'
  call source_tension_precalcul(t_fdtd3d%t_source_tension, &
                                t_fdtd3d%t_volume, &
				t_fdtd3d%t_milieu_volume, &
				t_fdtd3d%t_generateur)
end if

! -- STRUCTURE FIL, a besoin du tableau epsilon --
if (t_fdtd3d%flag_structure_fil) then
  print '(T5,"--- PRECALCUL STRUCTURE FIL ---")'
  call structure_fil_precalcul(t_fdtd3d%t_structure_fil, &
                               t_fdtd3d%t_volume,&
                               t_fdtd3d%t_milieu_volume,&
			       t_fdtd3d%t_generateur)
end if


! -- Champ lointain, a besoin des  epsilon et sigma --
if (t_fdtd3d%flag_champ_lointain_freq) then
  print '(T5,"--- PRECALCUL CHAMP LOINTAIN FREQUENCE ---")'
  call champ_lointain_freq_precalcul(t_fdtd3d%t_champ_lointain_freq, &
                                     t_fdtd3d%t_milieu_volume, &
				     t_fdtd3d%t_fichier_sortie,t_fdtd3d%t_maillage)
endif

! Stockage en volume, paramètres epsilon et sigma 
if (t_fdtd3d%flag_resultat_champ_volume) then
  print '(T5,"--- PRECALCUL RESULTAT CHAMP VOLUME 1 ---")'
  call resultat_champ_vol_precalcul1(t_fdtd3d%t_resultat_champ_volume, &
                        	t_fdtd3d%t_milieu_volume, &
				t_fdtd3d%t_fichier_sortie)
end if

!------------------------------------------------------------------------
! -- Libère la mémoire des tableaux 3D des parametres --
! -- epsilon, mu et conductivites --
if (t_fdtd3d%flag_structure) then 
  print '(T5,"--- PRECALCUL MILIEU VOLUME DEALLOCATE ---")'
  call milieu_volume_deallocate(t_fdtd3d%t_milieu_volume)
end if



! -- Allocation des tableaux 3D pour les 6 composantes des champs --
! -- Calcul coefficients multiplicatifs des champs --
print '(T5,"--- PRECALCUL CHAMP  ---")'
call champ_precalcul(t_fdtd3d%t_champ,t_fdtd3d%t_volume)
t_fdtd3d%flag_champ    = .true.

        		       
! -- A besoin de champ_precalcul --
print '(T5,"--- PRECALCUL FRONTIERES ---")'
call frontiere_precalcul(t_fdtd3d%t_frontiere, &
                         t_fdtd3d%t_champ)
t_fdtd3d%flag_frontiere = .true.
! -- Allocation et calcul de coefficients pour les milieux dispersifs
! -- Alias sur les composantes des champs --
if (t_fdtd3d%flag_milieu_dispersif .and. t_fdtd3d%flag_structure) then
  print '(T5,"--- PRECALCUL STRUCTURE DISPERSIVE ---")'
  allocate(t_fdtd3d%t_structure_dispersive)
  call structure_dispersive_precalcul(t_fdtd3d%t_structure_dispersive, &
                                      t_fdtd3d%t_milieu_dispersif, &
				      t_fdtd3d%t_structure, &
				      t_fdtd3d%t_volume, &
				      t_fdtd3d%t_champ )
				      
  if (t_fdtd3d%t_structure_dispersive%nb_structure <= 0) then
    deallocate(t_fdtd3d%t_structure_dispersive)
  else
    t_fdtd3d%flag_structure_dispersive = .true.
  end if
end if


! --  Alias sur les composantes de champ --
if (t_fdtd3d%flag_structure_fil) then
  print '(T5,"--- PRECALCUL STRUCTURE FIL ALIAS CHAMP ---")'
  call structure_fil_alias_champ(t_fdtd3d%t_structure_fil, &
                                 t_fdtd3d%t_champ, &
                                 t_fdtd3d%t_frontiere%t_cpml)
end if


! -- Injecteur d'ondes planes, a besoin de champ_precalcul et frontiere_precalcul -
if (t_fdtd3d%flag_onde_plane) then
  print '(T5,"--- PRECALCUL ONDE PLANE ---")'
  call onde_plane_precalcul(t_fdtd3d%t_onde_plane, &
                            t_fdtd3d%t_volume, &
                            t_fdtd3d%t_generateur, &
			    t_fdtd3d%t_champ, & 
			    t_fdtd3d%t_frontiere%t_cpml,&
			    t_fdtd3d%t_milieu_volume,&
			    t_fdtd3d%t_fichier_sortie)
endif

! -- Source de courant, alias sur les champs e et h --
if (t_fdtd3d%flag_source_courant) then
  print '(T5,"--- PRECALCUL SOURCE COURANT ---")'
  call source_courant_alias_champ(t_fdtd3d%t_source_courant, &
                                  t_fdtd3d%t_champ)
end if

! -- Source de tension, alias sur les champs e et h --
if (t_fdtd3d%flag_source_tension) then
  print '(T5,"--- PRECALCUL SOURCE TENSION ---")'
  call source_tension_alias_champ(t_fdtd3d%t_source_tension, &
                                  t_fdtd3d%t_champ)
end if



!--> Intervalles de stockage
if (t_fdtd3d%flag_liste_temps_freq) then
  print '(T5,"--- PRECALCUL LISTE TEMPS FREQUENCE ---")'
  call liste_temps_freq_precalcul(t_fdtd3d%t_liste_temps_freq, &
			               t_fdtd3d%t_fichier_sortie)
end if

!--> Résultats sur les point d'observation en champ 
if (t_fdtd3d%flag_resultat_champ) then
  print '(T5,"--- PRECALCUL RESULTAT CHAMP POINT ---")'
  call resultat_champ_precalcul(t_fdtd3d%t_resultat_champ, &
				t_fdtd3d%t_champ, &
				t_fdtd3d%t_volume, &
				t_fdtd3d%t_structure, &
				t_fdtd3d%t_fichier_sortie,&
				t_fdtd3d%t_milieu_volume)
end if

!--> Résultats sur les surfaces de champ 
if (t_fdtd3d%flag_resultat_champ_surf) then
  print '(T5,"--- PRECALCUL RESULTAT CHAMP SURFACE ---")'
  call resultat_champ_surf_precalcul(t_fdtd3d%t_resultat_champ_surf, &
                        	t_fdtd3d%t_volume, &
				t_fdtd3d%t_champ, &
				t_fdtd3d%t_fichier_sortie)
end if
!--> Résultats sur des volumes de champ 
if (t_fdtd3d%flag_resultat_champ_volume) then
  print '(T5,"--- PRECALCUL RESULTAT CHAMP VOLUME 2 ---")'
  call resultat_champ_vol_precalcul2(t_fdtd3d%t_resultat_champ_volume, &
				t_fdtd3d%t_champ, &
				t_fdtd3d%t_fichier_sortie)
end if

!--> Résultats V, I, Z
if (t_fdtd3d%flag_resultat_v_i_z) then
  print '(T5,"--- PRECALCUL RESULTAT V I Z ---")'
  call resultat_v_i_z_precalcul(t_fdtd3d%t_resultat_v_i_z, &
                        	t_fdtd3d%t_volume, &
				t_fdtd3d%t_champ, &
				t_fdtd3d%t_fichier_sortie)
end if


!--> Résultats
if (t_fdtd3d%flag_resultat_structure_fil) then
  print '(T5,"--- PRECALCUL RESULTAT STRUCTURE FIL ---")'
  call resultat_fil_precalcul(t_fdtd3d%t_resultat_structure_fil, &
					t_fdtd3d%t_structure_fil, &
					t_fdtd3d%t_fichier_sortie)
endif


!--> Champ lointain : Alias sur les champs --
if (t_fdtd3d%flag_champ_lointain_freq) then
  print '(T5,"--- PRECALCUL CHAMP LOINTAIN FREQUENCE ---")'
  call champ_lointain_freq_alias_champ(t_fdtd3d%t_champ_lointain_freq, &
                                       t_fdtd3d%t_champ)
endif

end subroutine fdtd3d_precalcul


! ==========================================================
! == Subroutine fdtd3d_excitation_H                       ==
! == Calcul pendant les itérations temporelles            ==
! == Excitation en  onde plane
!===========================================================	
subroutine fdtd3d_modif_excite_H(t_fdtd3d,iter)

type(st_fdtd3d), intent(inout) :: t_fdtd3d
integer, intent(in)   :: iter

!===   Début des traitements   ===

! -- Onde plane, mise à jour de H
if (t_fdtd3d%flag_onde_plane) &
 call onde_plane_calcul_champh(iter,t_fdtd3d%t_onde_plane,t_fdtd3d%t_champ)


! -- Structures dispersives, Mise à jour de H --
if (t_fdtd3d%flag_structure_dispersive ) then
  if (t_fdtd3d%t_structure_dispersive%flag_mu) &
  call structure_dispersive_H_calcul_H(t_fdtd3d%t_structure_dispersive)
end if

! -- Calcul des courants et des charges sur les fils  --
! -- Reactualisation des champs electriques tangentiels --
if (t_fdtd3d%flag_structure_fil) then
  call structure_fil_calcul_Emoy_I(t_fdtd3d%t_structure_fil,iter)
end if


end subroutine fdtd3d_modif_excite_H

! ==========================================================
! == Subroutine fdtd3d_modif_excite_E                     ==
! == Calcul pendant les itérations temporelles            ==
! == Excitation en tension, courant et onde plane
! == Modification de E dans le cas des structures filaires
! == et de l'annulation des composantes tangentielles de E
! == sur les plaques parfaitement conductrices
!===========================================================	
subroutine fdtd3d_modif_excite_E(t_fdtd3d,iter)

type(st_fdtd3d), intent(inout) :: t_fdtd3d
integer, intent(in)   :: iter


! -- Insertion des sources de courant --
if (t_fdtd3d%flag_source_courant) &
  call source_courant_calcul(t_fdtd3d%t_source_courant, iter)

! -- Insertion des sources de tension --
if (t_fdtd3d%flag_source_tension) &
  call source_tension_calcul(t_fdtd3d%t_source_tension, iter)

! -- Onde plane, mise à jour de E
if (t_fdtd3d%flag_onde_plane) &
  call onde_plane_calcul_champe(iter,t_fdtd3d%t_onde_plane,t_fdtd3d%t_champ)


! -- Structures dispersives, Mise à jour de E --
if (t_fdtd3d%flag_structure_dispersive ) then
  if (t_fdtd3d%t_structure_dispersive%flag_eps) &
  call structure_dispersive_E_calcul_E(t_fdtd3d%t_structure_dispersive)
end if



! -- Calcul des courants et des charges sur les fils  --
! -- Reactualisation des champs electriques tangentiels --
if (t_fdtd3d%flag_structure_fil) then
  call structure_fil_calcul_Qjonction(t_fdtd3d%t_structure_fil)
  call structure_fil_calcul_Q_E(t_fdtd3d%t_structure_fil)
end if



! -- Annulation des composantes du champ E sur les métallisations
! -- uniquement si le milieu du volume de calcul est homogène
if (t_fdtd3d%flag_structure .and. &
    (t_fdtd3d%t_champ%flag_dielectrique_homogene .or. &
    t_fdtd3d%t_champ%flag_diel_pertes_homogene )) &
  call champ_annule_e_tangent_metal(t_fdtd3d%t_champ,t_fdtd3d%t_structure) 

end subroutine fdtd3d_modif_excite_E

! ==========================================================
! == Subroutine fdtd3d_calcul_annexe                      ==
! == Calcul annexe pendant les itérations temporelles     ==
! == Concerne tous les traitements après le calcul sur les champs
! ==========================================================	
subroutine fdtd3d_calcul_annexe(t_fdtd3d,iter)

type(st_fdtd3d), intent(inout) :: t_fdtd3d
integer, intent(in)   :: iter

!===   Début des traitements   ===

if (t_fdtd3d%flag_liste_temps_freq) then
 call liste_temps_freq_calcul(t_fdtd3d%t_liste_temps_freq, iter)
end if

! -- Structures dispersives, Mise à jour de E et/ou --
if (t_fdtd3d%flag_structure_dispersive) then
  if (t_fdtd3d%t_structure_dispersive%flag_eps) &
    call  structure_dispersive_E_calcul_J(t_fdtd3d%t_structure_dispersive)
  if (t_fdtd3d%t_structure_dispersive%flag_mu) &
    call  structure_dispersive_H_calcul_M(t_fdtd3d%t_structure_dispersive)
end if

! -- resultat stockage d'un champ de référence pour l'onde plane --
if (t_fdtd3d%flag_onde_plane) then
  if (t_fdtd3d%t_onde_plane%flag_ptref) &
    call onde_plane_calcul_ptref(t_fdtd3d%t_onde_plane)
end if

! -- resultat stockage des composantes de champ --
if (t_fdtd3d%flag_resultat_champ) then
  call resultat_champ_calcul(t_fdtd3d%t_resultat_champ, &
                             t_fdtd3d%t_fichier_sortie)
end if

! -- resultat stockage des composantes de champ de surfaces--
if (t_fdtd3d%flag_resultat_champ_surf) then
  call resultat_champ_surf_calcul(t_fdtd3d%t_resultat_champ_surf, &
                             t_fdtd3d%t_fichier_sortie)

end if

! -- resultat sur les volumes de champ --
if (t_fdtd3d%flag_resultat_champ_volume) then
  call resultat_champ_vol_calcul(t_fdtd3d%t_resultat_champ_volume, &
                             t_fdtd3d%t_fichier_sortie)

end if



! -- resultat stockage V, I, Z
if (t_fdtd3d%flag_resultat_v_i_z) then
  call resultat_v_i_z_calcul(t_fdtd3d%t_resultat_v_i_z, &
		             t_fdtd3d%t_fichier_sortie)

end if



! -- resultat stockage et ecriture des grandeurs filaires --
if (t_fdtd3d%flag_resultat_structure_fil) then
  call resultat_structure_fil_calcul(t_fdtd3d%t_resultat_structure_fil, &
				     t_fdtd3d%t_fichier_sortie, &
				     iter)
end if


! -- Champ lointain --
if (t_fdtd3d%flag_champ_lointain_freq) then
  call champ_lointain_freq_calcul(t_fdtd3d%t_champ_lointain_freq)
endif


end subroutine fdtd3d_calcul_annexe


! ==========================================================
! == Subroutine fdtd3d_affichage                          ==
! == Affiche les caracteristiques du RUN dans le terminal ==
! ==========================================================	
subroutine fdtd3d_affichage(t_fdtd3d)

type(st_fdtd3d), intent(inout) :: t_fdtd3d
				
call volume_affichage(t_fdtd3d%t_volume)
call frontiere_affichage(t_fdtd3d%t_frontiere)


! -- Les structures --
if (t_fdtd3d%flag_structure) &
  call structure_affichage(t_fdtd3d%t_structure)

! -- Milieux dispersifs --
if (t_fdtd3d%flag_milieu_dispersif) &
  call milieu_dispersif_affichage(t_fdtd3d%t_milieu_dispersif)

! -- Milieux dispersifs --
if (t_fdtd3d%flag_liste_milieu_simple) &
  call liste_milieu_simple_affichage(t_fdtd3d%t_liste_milieu_simple)

! -- structure dipersive --
if (t_fdtd3d%flag_structure_dispersive) then
  call structure_dispersive_affichage(t_fdtd3d%t_structure_dispersive)
end if

! -- Insertion des sources de courant --
if (t_fdtd3d%flag_source_courant) &
  call source_courant_affichage(t_fdtd3d%t_source_courant)

! -- Insertion des sources de tension --
if (t_fdtd3d%flag_source_tension) &
  call source_tension_affichage(t_fdtd3d%t_source_tension)


! Dans l'initialisation
!if (t_fdtd3d%flag_liste_temps_freq) then
!  call liste_temps_freq_affichage(t_fdtd3d%t_liste_temps_freq)
!endif


if (t_fdtd3d%flag_structure_fil) then
  call structure_fil_affichage(t_fdtd3d%t_structure_fil)
endif



if (t_fdtd3d%flag_resultat_structure_fil) then
  call resultat_fil_affichage(t_fdtd3d%t_resultat_structure_fil)
endif


! -- Champ lointain --
if (t_fdtd3d%flag_champ_lointain_freq) then
  call champ_lointain_freq_affichage(t_fdtd3d%t_champ_lointain_freq)
endif

end subroutine fdtd3d_affichage


! ==========================================================
! == Subroutine fdtd3d_postcalcul                         ==
! == Calcul après les itérations temporelles              ==
! ==========================================================	
subroutine fdtd3d_postcalcul(t_fdtd3d)

type(st_fdtd3d), intent(inout) :: t_fdtd3d

! -- resultat stockage des composantes de champ

! -- Champ lointain --
if (t_fdtd3d%flag_champ_lointain_freq) then
  call champ_lointain_freq_postcalcul(t_fdtd3d%t_champ_lointain_freq, &
                                      t_fdtd3d%t_volume,t_fdtd3d%t_milieu_volume)
endif
				
end subroutine fdtd3d_postcalcul


! ==========================================================
! == Subroutine fdtd3d_impression                         ==
! == Ecriture des résultats dans les fichiers de sortie   ==
! ==========================================================
subroutine fdtd3d_impression(t_fdtd3d)

type(st_fdtd3d), intent(inout) :: t_fdtd3d


if (t_fdtd3d%flag_onde_plane) then
  call onde_plane_impression(t_fdtd3d%t_onde_plane, &
                           t_fdtd3d%t_fichier_sortie)
end if

! -- stockage en fréquence de points de champ --
if (t_fdtd3d%flag_resultat_champ) then
  call resultat_champ_impression(t_fdtd3d%t_resultat_champ, &
                                 t_fdtd3d%t_fichier_sortie, &
                                 t_fdtd3d%t_generateur)
end if

! -- stockage en fréquence de surfaces de champ --
if (t_fdtd3d%flag_resultat_champ_surf) then
  call resultat_champ_surf_impression(t_fdtd3d%t_resultat_champ_surf, &
                                 t_fdtd3d%t_fichier_sortie,&
				 t_fdtd3d%t_generateur)
end if

! -- stockage en fréquence sur les volumes de champ --
if (t_fdtd3d%flag_resultat_champ_volume) then
  call resultat_champ_vol_impression(t_fdtd3d%t_resultat_champ_volume, &
                                 t_fdtd3d%t_fichier_sortie,&
				 t_fdtd3d%t_generateur)
end if

! -- stockage en fréquence de V, I, Z
if (t_fdtd3d%flag_resultat_v_i_z) then
  call resultat_v_i_z_impression(t_fdtd3d%t_resultat_v_i_z, &
				t_fdtd3d%t_fichier_sortie, &
				t_fdtd3d%t_generateur)

end if


! -- stockage en fréquence sur les fils
if (t_fdtd3d%flag_resultat_structure_fil) then
  call resultat_fil_impression(t_fdtd3d%t_resultat_structure_fil, &
				  t_fdtd3d%t_fichier_sortie,&
				  t_fdtd3d%t_generateur)
end if 



! -- Champ lointain --
if (t_fdtd3d%flag_champ_lointain_freq) then
  call champ_lointain_freq_impression(t_fdtd3d%t_champ_lointain_freq, &
                                      t_fdtd3d%t_fichier_sortie,&
				      t_fdtd3d%t_generateur)
endif

end subroutine fdtd3d_impression


! ==========================================================
! == Subroutine fdtd3d_temps_cpu_affichage                ==
! == Affichage des temps CPU                              ==
! ==========================================================
subroutine fdtd3d_temps_cpu_affichage(fd)

type(st_fdtd3d), intent(inout) :: fd

real :: fa,tpml,tu

if (fd%t_frontiere%t_cpml%nb_cell_pml>0) then
  tpml = fd%t_temps_cpu%t_frontiere_e+fd%t_temps_cpu%t_frontiere_h
  tu   = fd%t_temps_cpu%t_calcul_e   +fd%t_temps_cpu%t_calcul_h
  Fa = 1.0+(tpml/fd%t_frontiere%t_cpml%nb_cell_pml)/(tu/fd%t_champ%nb_cell_tot)
  Print '(T10,"Rapport Temps CPU cell PML/Temps CPU cell utile =",F8.3)',Fa
end if

call temps_cpu_affichage(fd%t_temps_cpu)

end subroutine fdtd3d_temps_cpu_affichage

! ==========================================================
! == Subroutine fdtd3d_deallocate                         ==
! == Desalloue la memoire pour les champs dynamiques      ==
! ==========================================================
subroutine fdtd3d_deallocate(t_fdtd3d)

type(st_fdtd3d), intent(inout) :: t_fdtd3d


return
! -- volume --
call volume_deallocate(t_fdtd3d%t_volume)
! -- champ ---
if (t_fdtd3d%flag_champ) then
  print '("--- Libération mémoire module champ ---")'
  call champ_deallocate(t_fdtd3d%t_champ)
end if

! -- Les frontieres --
if (t_fdtd3d%flag_frontiere) then
  print '("--- Libération mémoire module frontiere ---")'
  call frontiere_deallocate(t_fdtd3d%t_frontiere)
end if

if (t_fdtd3d%flag_surface_huygens) then
  print '("--- Libération mémoire module surface_huygens ---")'
  call surface_huygens_deallocate(t_fdtd3d%t_surface_huygens)
endif


if (t_fdtd3d%flag_liste_milieu_simple) then
  print '("--- Libération mémoire module liste_milieu ---")'
  call liste_milieu_simple_deallocate(t_fdtd3d%t_liste_milieu_simple)
  deallocate(t_fdtd3d%t_liste_milieu_simple)
end if

! -- Les structures --
if (t_fdtd3d%flag_structure) then
  print '("--- Libération mémoire module structure ---")'
  call structure_deallocate(t_fdtd3d%t_structure)
!  deallocate(t_fdtd3d%t_structure)
end if

! -- Structure fils --
if (t_fdtd3d%flag_structure_fil) then
  print '("--- Libération mémoire module structure_fil ---")'
  call structure_fil_deallocate(t_fdtd3d%t_structure_fil)
end if 

if (t_fdtd3d%flag_onde_plane) then
  print '("--- Libération mémoire module onde_plane ---")'
  call onde_plane_deallocate(t_fdtd3d%t_onde_plane)
endif

! -- source de courant --
if (t_fdtd3d%flag_source_courant) then
  print '("--- Libération mémoire module source_courant ---")'
  call source_courant_deallocate(t_fdtd3d%t_source_courant)
  deallocate(t_fdtd3d%t_source_courant)
end if

! -- source de tension --
if (t_fdtd3d%flag_source_tension) then
   print '("--- Libération mémoire module source_tension ---")'
 call source_tension_deallocate(t_fdtd3d%t_source_tension)
  deallocate(t_fdtd3d%t_source_tension)
end if

! -- fonction source --
if (t_fdtd3d%flag_generateur) then
  print '("--- Libération mémoire module generateur ---")'
  call generateur_deallocate(t_fdtd3d%t_generateur)
  deallocate(t_fdtd3d%t_generateur)
end if  

if (t_fdtd3d%flag_zone_angulaire) then
  print '("--- Libération mémoire module zone_angulaire ---")'
  call zone_angulaire_deallocate(t_fdtd3d%t_zone_angulaire)
endif


! resultat ...

! resultat champ
if (t_fdtd3d%flag_resultat_champ) then
  print '("--- Libération mémoire module resultat_champ_point ---")'
  call resultat_champ_deallocate(t_fdtd3d%t_resultat_champ)
end if

! resultat champ surface
if (t_fdtd3d%flag_resultat_champ_surf) then
  print '("--- Libération mémoire module resultat_champ_surface ---")'
  call resultat_champ_surf_deallocate(t_fdtd3d%t_resultat_champ_surf)
end if

! resultat en volume
if (t_fdtd3d%flag_resultat_champ_volume) then
  print '("--- Libération mémoire module resultat_champ_volume ---")'
  call resultat_champ_vol_deallocate(t_fdtd3d%t_resultat_champ_volume)
  deallocate(t_fdtd3d%t_resultat_champ_volume)
end if

! resultat tension, courant,impédance
if (t_fdtd3d%flag_resultat_v_i_z) then
  print '("--- Libération mémoire module resultat_v_i_z ---")'
  call resultat_v_i_z_deallocate(t_fdtd3d%t_resultat_v_i_z)
  deallocate(t_fdtd3d%t_resultat_v_i_z)
end if

! -- stockage en fréquence sur les fils
if (t_fdtd3d%flag_resultat_structure_fil) then
  print '("--- Libération mémoire module resultat_fil ---")'
  call resultat_fil_deallocate(t_fdtd3d%t_resultat_structure_fil)
  deallocate(t_fdtd3d%t_resultat_structure_fil)
end if 



if (t_fdtd3d%flag_champ_lointain_freq) then
  print '("--- Libération mémoire module resultat_champ_lointain_freq ---")'
  call champ_lointain_freq_deallocate(t_fdtd3d%t_champ_lointain_freq)
  deallocate(t_fdtd3d%t_champ_lointain_freq)
endif

end subroutine fdtd3d_deallocate


! ==========================================================
! == Subroutine fdtd3d_fermeture_fichier()                ==
! == Ferme tous les fichiers qu'il y a fermer             ==
! ==========================================================
subroutine fdtd3d_fermeture_fichier(f)

type(st_fdtd3d), intent(inout) :: f


! resultat structure fil
if (f%flag_resultat_structure_fil) then
  call resultat_fil_fermeture(f%t_resultat_structure_fil, &
					f%t_fichier_sortie)
end if


call fichier_sortie_fermeture(f%t_fichier_sortie)


end subroutine fdtd3d_fermeture_fichier


! ==========================================================
! == Fin du module                                        ==
! ==========================================================
end module mfdtd_fdtd3d	



