!/////////////////////////////////////////////////////////////////////////////
!// Name:        mfdtd_identifiant.f90
!// Purpose:     Initialisation de tous les identifiants
!//                du répertoire fdtd
!// Author:      Christophe Guiffaut
!// Modified by:
!// Created:     25 Avril 2007
!// Lieu     : XLIM - Faculté des sciences - 123 Av. Albert Thomas - Limoges
!// Copyright:   (c) CNRS, Université de Limoges
!// Licence  : CECILL-C - Octobre 2006
!/////////////////////////////////////////////////////////////////////////////

module mfdtd_identifiant

implicit none

!*** BLOC volume de calcul ***
character(LEN=*), parameter :: BLOC_VOLUME = 'volume_calcul'

character(LEN=*), parameter :: BV_NP_XYZ      = 'nombre_processus'
character(LEN=*), parameter :: BV_NXNYNZ      = 'nxnynz'
character(LEN=*), parameter :: BV_LXLYLZ      = 'lxlylz'
character(LEN=*), parameter :: BV_DXDYDZ      = 'dxdydz'
character(LEN=*), parameter :: BV_CDTMAX      = 'cdtmax'
character(LEN=*), parameter :: BV_DUREE_TOTAL = 'duree_totale'
character(LEN=*), parameter :: BV_DUREE       = 'duree'
character(LEN=*), parameter :: BV_TEMPS_CPU   = 'temps_cpu'
character(LEN=*), parameter :: BV_DUREE_AUTO  = 'auto'
character(LEN=*), parameter :: BV_DUREE_SEMIAUTO = 'semiauto'
character(LEN=*), parameter :: BV_EPSILON_R   = 'epsilon_r'
character(LEN=*), parameter :: BV_MU_R        = 'mu_r'
character(LEN=*), parameter :: BV_SIGMA_E     = 'sigma_e'
character(LEN=*), parameter :: BV_SIGMA_H     = 'sigma_h'
character(LEN=*), parameter :: BV_MAILLAGE_NU_X     = 'maillage_nu_x'
character(LEN=*), parameter :: BV_MAILLAGE_NU_Y     = 'maillage_nu_y'
character(LEN=*), parameter :: BV_MAILLAGE_NU_Z     = 'maillage_nu_z'

character(LEN=*), parameter :: BV_SCHEMA_EXPONENT  = 'schema_fdtd_exponentiel'
character(LEN=*), parameter :: BV_SCHEMA_LINEAIRE = 'schema_fdtd_lineaire'
character(LEN=*), parameter :: BV_NON_MOY_MILIEU  = 'non_moyennage_milieu'
character(LEN=*), parameter :: BV_ORIGINE_CELL    = 'origine_cell' 
character(LEN=*), parameter :: BV_ORIGINE_REELLE  = 'origine_reelle' 

!*** BLOC sur les frontières ***
character(LEN=*), parameter :: BLOC_FRONTIERE ='frontiere'


!*** BLOC sur les sources ***
character(LEN=*), parameter :: BLOC_SOURCE_TENSION ='source_tension'
character(LEN=*), parameter :: BLOC_SOURCE_COURANT ='source_courant'
character(LEN=*), parameter :: BLOC_SOURCE_DIPOLAIRE ='source_dipolaire'

!*** BLOC ondeplane ***
character(LEN=*), parameter :: BLOC_ONDE_PLANE ='onde_plane'

character(LEN=*), parameter :: BOP_INJECTEUR    = 'injecteur'
character(LEN=*), parameter :: BOP_DIM_HUYGS    = 'dim_huygens'
character(LEN=*), parameter :: BOP_FLAG_SURFACE = 'surface'
character(LEN=*), parameter :: BOP_XOYINF = 'xoyinf'
character(LEN=*), parameter :: BOP_XOYSUP = 'xoysup'
character(LEN=*), parameter :: BOP_YOZINF = 'yozinf'
character(LEN=*), parameter :: BOP_YOZSUP = 'yozsup'
character(LEN=*), parameter :: BOP_XOZINF = 'xozinf'
character(LEN=*), parameter :: BOP_XOZSUP = 'xozsup'
character(LEN=*), parameter :: BOP_MILIEU_STRATIFIE_X = 'milieu_stratifie_x'
character(LEN=*), parameter :: BOP_MILIEU_STRATIFIE_Y = 'milieu_stratifie_y'
character(LEN=*), parameter :: BOP_MILIEU_STRATIFIE_Z = 'milieu_stratifie_z'
character(LEN=*), parameter :: BOP_MUR_ELECTRIQUE = 'mur_electrique'

!*** BLOC CAO ***
character(LEN=*), parameter :: BLOC_CAO ='cao'
character(LEN=*), parameter :: BCAO_FAMILLE ='famille'
character(LEN=*), parameter :: BCAO_OBJET  ='objet'
character(LEN=*), parameter :: BCAO_PLAQUE_RECT ='plaque_rect'
character(LEN=*), parameter :: BCAO_BOITE ='boite'
character(LEN=*), parameter :: BCAO_CYL   ='cylindre'

!*** BLOC Structure ***
character(LEN=*), parameter :: BLOC_STRUCTURE ='structure'
character(LEN=*), parameter :: BS_OBJET_DEFAUT ='commun'

!*** BLOCS sur les structures de type fils minces ***
character(LEN=*), parameter :: BLOC_FIL ='structure_fil'
character(LEN=*), parameter :: BLOC_FIL_OBLIQUE ='fil_oblique'
character(LEN=*), parameter :: BLOC_TORON_FILAIRE ='toron_filaire'
character(LEN=*), parameter :: BLOC_FIL_GIRAUDON ='structure_filaire_generalisee'

!*** BLOCS sur les résultats ***
character(LEN=*), parameter :: BLOC_RES_CHAMP_PT ='resultat_champ_point'
character(LEN=*), parameter :: BLOC_RES_CHAMP_SURF ='resultat_champ_surface'
character(LEN=*), parameter :: BLOC_RES_CHAMP_VOL ='resultat_champ_volume'
character(LEN=*), parameter :: BLOC_RES_V_I_Z ='resultat_v_i_z'

character(LEN=*), parameter :: BLOC_CHAMP_LOINTAIN = 'champ_lointain'

end module mfdtd_identifiant
