!/////////////////////////////////////////////////////////////////////////////
!// Name:        m_gene_identifiant.f90
!// Purpose:     Initialisation de tous les identifiants des fonctions sources
!//              
!// Author:      Christophe Guiffaut
!// Modified by:
!// Created:     08 octobre 2004
!// Lieu     : XLIM - Faculté des sciences - 123 Av. Albert Thomas - Limoges
!// Copyright:   (c) CNRS, Université de Limoges
!// Licence  : CECILL-C - Octobre 2006
!/////////////////////////////////////////////////////////////////////////////

module m_gene_identifiant

implicit none


!*** SOUS BLOC des différentes fonctions ***

character(LEN=*), parameter :: BLOC_FONCTION_SOURCE    = 'fonction_source'
character(LEN=*), parameter :: BLOC_FS_SINUS           = 'sinus'
character(LEN=*), parameter :: BLOC_FS_GAUSSIENNE      = 'gaussienne'
character(LEN=*), parameter :: BLOC_FS_SINO_GAUSSIENNE = 'sino_gaussienne'
character(LEN=*), parameter :: BLOC_FS_DERIVEE_GAUSSIENNE = 'derivee_gaussienne'
character(LEN=*), parameter :: BLOC_FS_DOUBLE_EXPO     = 'bi_expo'
character(LEN=*), parameter :: BLOC_FS_ECHELON_EXPO    = 'echelon_exponentielle'
character(LEN=*), parameter :: BLOC_FS_RAYLEIGH        = 'ondelette_rayleigh'
character(LEN=*), parameter :: BLOC_FS_PULSE_SINUS     = 'pulse_sinus'
character(LEN=*), parameter :: BLOC_FS_IEMN_EXPO_Q     = 'iemn_expo_quotient'
character(LEN=*), parameter :: BLOC_FS_FCT_FICHIER     = 'fonction_fichier'
character(LEN=*), parameter :: BLOC_FS_HEIDLER         = 'foudre_heidler'


!--- Mot clé commun à plusieurs fonction sources
character(LEN=*), parameter :: BFS_DUREE     = 'duree'
character(LEN=*), parameter :: BFS_TM        = 'temps_montee'
character(LEN=*), parameter :: BFS_LMH       = 'largeur_mihauteur'
character(LEN=*), parameter :: BFS_FMAX      = 'fmax'
character(LEN=*), parameter :: BFS_F0        = 'freq_centrale'
character(LEN=*), parameter :: BFS_ATT_PIED  = 'att_pied'
character(LEN=*), parameter :: BFS_ATT_FMAX  = 'att_fmax'

!--- Fonction sinus ---

!--- Fonction sino-gaussienne ---
character(LEN=*), parameter :: BFS_SG_BANDE = 'bande_freq'


!--- Fonction ondelette de rayleigh ---
character(LEN=*), parameter :: BFS_OR_F_AMAX = 'freq_de_amax'
character(LEN=*), parameter :: BFS_OR_ORDRE  = 'ordre'

!--- Fonction iemn exponentielle quotient ---
character(LEN=*), parameter :: BFS_IEQ_ALPHA = 'alpha'
character(LEN=*), parameter :: BFS_IEQ_BETA = 'beta'
character(LEN=*), parameter :: BFS_IEQ_TPQ = 'tpq'

!--- Fonction échelon exponentielle ---
character(LEN=*), parameter :: BFS_EE_PENTE = 'pente'



end module m_gene_identifiant

